/****************************************************************************************************************
* This is a NTPCLIENT.c control program 
* currently , it accessed 32 time servers
* when system detected "WAN started" , then begin to send ntp packet , until it gets response from the time server.
* at the begining, the period is 1 --> 2 --> 4 --> 8 -->15 -->30 --> 60secs -->" programmer define "
* ( time servers on 13 groups)
* note :in my case:
* 13 * (1+2+4+8+15+30+60+90+90+120+120+120+120+120) = 13 * 900 secs = 195 mins 
* 13 * sleep(2) *max_cycle  ~ 4 mins
* for performance , it will send ntp packet to 2~3 time servers at the same time ,
* and the system  must  get response from time server in about 3 hrs . ( this control program will stop sending packet 
* after the time )
*
* 1. The one who want to modify the ntp packet cycle can just modify "cycle_period[]"
* 2. The one who need the forever loop can modify the "if" condition :  if(cycle_no>=max_cycle)
*  V1.0
*  Arthur Lin  , Gemtek 
*  2003.8.21
*
****************************************************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <linux/types.h>

#include <linux/fcntl.h>
#include <linux/stat.h>
#include <unistd.h>

#include <time.h>
#include <sys/time.h>
#define   T_ZONE		8

int check_time(void);

#include <nvram.h>
#include <vendor.h>
#include "GetHostByName.h"

int main (int argc, char * argv[])
{
DBG();
	int 	ret , i;
	char	trytime=0;
	unsigned int cycle_period[]={1,2,4,8,15,30,60,90,120,120,120,120,120};
	char cmdbuf[128];
	char *time_server[]={
#if NETGEAR
									"12.7.210.177", //time-a.netgear.com
									"69.25.106.19", //time-c.netgear.com
#endif
									"192.53.103.104",
									"129.69.1.153",
#if 0
									"216.152.68.16",
									"204.123.2.5",
									"128.118.46.3",
									"129.6.15.29",
									"133.100.9.2",
									"207.200.81.113",
									"209.81.9.7",
									"143.232.55.5",
									"128.250.36.2",
									"204.123.2.5",
									"137.92.140.80",
									"128.250.36.3",
									"200.19.119.69",
									"142.3.100.2",
									"136.159.2.254",
									"128.233.3.100",
									"128.233.3.101",
									"193.5.216.14",
									"129.132.2.21",
									"146.83.8.200",
									"200.68.60.246",
									"195.113.144.201",
									"131.188.3.220",
									"131.188.3.221",
									"131.188.3.222",
									"131.188.3.223",
									"130.149.17.21",
									"130.149.17.8",
									"192.53.103.103",
									"212.242.86.186",
									"192.38.7.240",
#endif
									(char*)0,
									};
									

	struct timezoneDNS{
		int timezone;
		char *server1;
		char *server2;
		int index;
	};
	struct timezoneDNS timezone_DNS[]={
		{-1,"time-h.netgear.com","time-a.netgear.com",17},
		{-2,"time-h.netgear.com","time-a.netgear.com",16},
		{-3,"time-h.netgear.com","time-a.netgear.com",14},	
		{-4,"time-a.netgear.com","time-b.netgear.com",13},	
		{-5,"time-a.netgear.com","time-b.netgear.com",11},	
		{-6,"time-a.netgear.com","time-b.netgear.com",9},	
		{-7,"time-b.netgear.com","time-c.netgear.com",7},	
		{-8,"time-b.netgear.com","time-c.netgear.com",5},	
		{-9,"time-b.netgear.com","time-c.netgear.com",4},	
		{-10,"time-c.netgear.com","time-d.netgear.com",3},		
		{-11,"time-c.netgear.com","time-d.netgear.com",2},		
		{-12,"time-c.netgear.com","time-d.netgear.com",1},	
		{12,"time-d.netgear.com","time-e.netgear.com",36},			
		{11,"time-d.netgear.com","time-e.netgear.com",34},
		{10,"time-d.netgear.com","time-e.netgear.com",32},
		{9,"time-d.netgear.com","time-e.netgear.com",31},
		{8,"time-e.netgear.com","time-f.netgear.com",29},	
		{7,"time-e.netgear.com","time-f.netgear.com",28},	
		{6,"time-e.netgear.com","time-f.netgear.com",27},		
		{5,"time-f.netgear.com","time-g.netgear.com",26},	
		{4,"time-f.netgear.com","time-g.netgear.com",25},	
		{3,"time-f.netgear.com","time-g.netgear.com",24},	
		{2,"time-g.netgear.com","time-h.netgear.com",22},	
		{1,"time-g.netgear.com","time-h.netgear.com",20},	
		{0,"time-g.netgear.com","time-h.netgear.com",18},
		{NULL, NULL, NULL,NULL},													
	};
	struct hostent *h;
	char ipstr[20], timezone, *NTPserver1, *NTPserver2;
	struct in_addr addr;
	struct timezoneDNS *pDNSlist;
DBG();	
	timezone = atoi(nvram_get("timezone_index"));	
	NTPserver1 = "time-a.netgear.com";
	NTPserver2 = "time-c.netgear.com";	
	for(pDNSlist = &timezone_DNS[0]; pDNSlist->timezone; pDNSlist++)
	{	
		if(timezone == pDNSlist->index)
		{
			NTPserver1 = pDNSlist->server1;
			NTPserver2 = pDNSlist->server2;
			break;
		}
	}


	h = MyGetHostByName(NTPserver1);
	if (!h) {
		//dbg_printf("set ntp_server1 to %s\n",  time_server[0]);
		nvram_set("ntp_server1", time_server[0]);
	}
	else {
		memcpy(&addr, h->h_addr, sizeof(addr));	
		strcpy(ipstr,inet_ntoa(addr));
		//dbg_printf("exeNtp: %s IP =%s\n",NTPserver1,ipstr);
		nvram_set("ntp_server1", ipstr);
	}

		
	
	
	h = MyGetHostByName(NTPserver2);	
	if (!h) {
		//dbg_printf("set ntp_server2 to %s\n",  time_server[1]);
		nvram_set("ntp_server2", time_server[1]);
	} else {
		memcpy(&addr, h->h_addr, sizeof(addr));	
		strcpy(ipstr,inet_ntoa(addr));	
		//dbg_printf("exeNtp: %s IP =%s\n",NTPserver2,ipstr);
		nvram_set("ntp_server2", ipstr);				
	}

#ifdef NTP_WITH_DEFAULT_SERVER
			if(strlen(nvram_safe_get("ntp_server1")) > 0)
			{
				if(!strcmp(nvram_safe_get("ntp_server1"), "Other")) {
					//dbg_printf("exeNtp : Get 1st ntp server : %s\n", nvram_safe_get("ntp_server_other1"));
					sprintf( cmdbuf ,"/bin/Getntp -h %s -s -i 3 &", nvram_safe_get("ntp_server_other1"));
				}
				else {
					//dbg_printf("exeNtp : Get 1st ntp server : %s\n", nvram_safe_get("ntp_server1"));
					sprintf( cmdbuf ,"/bin/Getntp -h %s -s -i 3 &", nvram_safe_get("ntp_server1"));
				}
			  system ( cmdbuf );
			}
			
			if(strlen(nvram_safe_get("ntp_server2")) > 0)
			{
				if(!strcmp(nvram_safe_get("ntp_server2"), "Other")) {
					//dbg_printf("exeNtp : Get 1st ntp server : %s\n", nvram_safe_get("ntp_server_other2"));
					sprintf( cmdbuf ,"/bin/Getntp -h %s -s -i 3 &", nvram_safe_get("ntp_server_other2"));
				}
				else {
					//dbg_printf("exeNtp : Get 2nd ntp server : %s\n", nvram_safe_get("ntp_server2"));				
					sprintf( cmdbuf ,"/bin/Getntp -h %s -s -i 3 &", nvram_safe_get("ntp_server2"));
				}
			  system ( cmdbuf );
			}
			
			if(strlen(nvram_safe_get("ntp_server3")) > 0)
			{
				//dbg_printf("exeNtp : Get 3rd ntp server : %s\n", nvram_safe_get("ntp_server3"));				
				sprintf( cmdbuf ,"/bin/Getntp -h %s -s -i 3 &", nvram_safe_get("ntp_server3"));
			  system ( cmdbuf );
			}			   
#endif			

									
	for ( i = 0 ;time_server[i] != NULL ; i++ )
	{
		sprintf( cmdbuf ,"/bin/Getntp -h %s -s -i 3 &",time_server[i] );					
		system ( cmdbuf );
		sleep(5);
		if( check_time() )// Time is greater than 1970
		{
      			  printf("Got time.\n");
      			  nvram_set("got_time","1");

#if NETGEAR
      			  /* log the initial message for first time */
      			  if ((atoi(nvram_safe_get("got_time"))==1) && (atoi(nvram_safe_get("log_init"))==0)){
				gemtek_log(SECURITY_LOG, "[Initialized]");
				nvram_set("log_init","1");
      			  }
#endif
			break;
		}
	}          
                    

	return 0;
}

int check_time(void)
{

	struct 	tm			*rv_tm;
	struct 	timezone	curtz;
	struct 	timeval		curtime;
	time_t	timesec , timenow;


	gettimeofday(&curtime, &curtz);
	timesec = curtime.tv_sec;
	timesec = timesec + (3600 * T_ZONE);
	rv_tm = gmtime(&timesec);
	
	timenow = time( (time_t*) 0);
	//printf(" The year is %d \n", (rv_tm->tm_year+1900));
#if MARVELL_BOARD /* the marvell board default year is 2000, our board is 1903 */
	if ((rv_tm->tm_year+1900) == 2000) {
		return 0;
	}
	else if ((rv_tm->tm_year+1900) == 1903) {
		return 0;
	}
	else if ((rv_tm->tm_year+1900) < 2006 ) {
		return 0;
	}
#else
	if ((rv_tm->tm_year+1900) == 1970)
		return 0;
#endif
	else
		return 1;

}

