#include	"gtk_mm.h"


//#ifdef		_GTK_MM_System_
#if 0
#define	_MoreDBGInfo_

#ifdef		_MoreDBGInfo_
unsigned char		TmpBuf [ 128 ];
#endif		/* end of _MoreDBGInfo_ */

void		OutputDBGMessage ( unsigned char *msg )
{
	FILE		*fptr = NULL;

	if ( NULL == msg ) {
		return;
	} else if ( 0 == strlen ( msg ) ) {
		return;
	} else {
//		if ( NULL == ( fptr = fopen ( "/dev/console" , "w+" ) ) ) {
		if ( NULL == ( fptr = fopen ( "/tmp/gtk_mm" , "w+" ) ) ) {
			printf("OutputDBGMessage: can't open /dev/console");
			return;
		} else {
			fprintf ( fptr , msg );
			printf("OutputDBGMessage:%s\n",msg);
			fclose ( fptr );
			fptr = NULL;
		}
	}
	return;
}

void		InitMemoryAddressArray ( void )
{
	unsigned int		i = 0;

	for ( i = 0 ; i < MemPointArraySize ; i++ ) {
		MemPointArray[i].MemAddr = NULL;
		MemPointArray[i].MemSize = 0;
	}

	return;
}

void		RecordMemoryAddressToArray ( void *MemAddr , size_t MemSize )
{
	unsigned int		i = 0;
#ifdef		_MoreDBGInfo_
	unsigned int		allocated_memory_size = 0;
#endif		/* end of _MoreDBGInfo_ */

	if ( ( NULL == MemAddr ) || ( 0 >= MemSize ) ) {
		OutputDBGMessage ( "( ( NULL == MemAddr ) || ( 0 >= MemSize ) )\n" );
		return;
	}

	for ( i = 0 ; i < MemPointArraySize ; i++ ) {
		if ( ( NULL == MemPointArray[i].MemAddr ) && ( 0 == MemPointArray[i].MemSize ) ) {
#ifdef		_MoreDBGInfo_
			memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
			sprintf ( TmpBuf , "RecordMemoryAddressToArray :: Record#%d -> %d bytes\n" , i , MemSize );
			OutputDBGMessage ( TmpBuf );
			memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
#endif		/* end of _MoreDBGInfo_ */

			MemPointArray[i].MemAddr = MemAddr;
			MemPointArray[i].MemSize = MemSize;
			return;
		}
#ifdef		_MoreDBGInfo_
		allocated_memory_size += MemPointArray[i].MemSize;
#endif		/* end of _MoreDBGInfo_ */
	}

#ifdef		_MoreDBGInfo_
	memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
	sprintf ( TmpBuf , "RecordMemoryAddressToArray -> allocated_memory_size = %d bytes\n" , allocated_memory_size );
	OutputDBGMessage ( TmpBuf );
	memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
#endif		/* end of _MoreDBGInfo_ */

	OutputDBGMessage ( "MemPointArray ... table is full\n" );
	return;
}

void		DeleteRecordFromArray ( void *MemAddr )
{
	unsigned int		i = 0;

	if ( NULL == MemAddr ) {
		OutputDBGMessage ( "DeleteRecordFromArray ... ( NULL == MemAddr )\n" );
		return;
	}

	for ( i = 0 ; i < MemPointArraySize ; i++ ) {
		if ( MemAddr == MemPointArray[i].MemAddr ) {
#ifdef		_MoreDBGInfo_
			memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
			sprintf ( TmpBuf , "DeleteRecordFromArray :: Record#%d -> %d bytes\n" , i , MemPointArray[i].MemSize );
			OutputDBGMessage ( TmpBuf );
			memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
#endif		/* end of _MoreDBGInfo_ */

			MemPointArray[i].MemAddr = NULL;
			MemPointArray[i].MemSize = 0;
			return;
		}
	}

#ifdef		_MoreDBGInfo_
	memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
	sprintf ( TmpBuf , "DeleteRecordFromArray -> can't seek any record for MemAddr=%#x\n" , (unsigned int) MemAddr );
	OutputDBGMessage ( TmpBuf );
	memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
#endif		/* end of _MoreDBGInfo_ */

	return;
}

void		GTK_FreeMemory ( void )
{
	unsigned int		i = 0;
#ifdef		_MoreDBGInfo_
	unsigned int		allocated_memory_size = 0;
#endif		/* end of _MoreDBGInfo_ */

	for ( i = 0 ; i < MemPointArraySize ; i++ ) {
		if ( NULL != MemPointArray[i].MemAddr ) {
#ifdef		_MoreDBGInfo_
			memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
			sprintf ( TmpBuf , "GTK_FreeMemory -> Record#%d --> %d bytes\n" , i , MemPointArray[i].MemSize );
			OutputDBGMessage ( TmpBuf );
			memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
			allocated_memory_size += MemPointArray[i].MemSize;
#endif		/* end of _MoreDBGInfo_ */

			free ( MemPointArray[i].MemAddr );
			MemPointArray[i].MemAddr = NULL;
			MemPointArray[i].MemSize = 0;
		}
	}

#ifdef		_MoreDBGInfo_
	memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
	sprintf ( TmpBuf , "GTK_FreeMemory -> non-freed memory size = %d bytes, free it now.\n" , allocated_memory_size );
	OutputDBGMessage ( TmpBuf );
	memset ( TmpBuf , '\0' , sizeof ( TmpBuf ) );
#endif		/* end of _MoreDBGInfo_ */

	return;
}

void		*gtk_malloc ( size_t size )
{
	void		*allocated_memory = NULL;
	if ( size > 0 ) {
		if ( NULL != ( allocated_memory = malloc ( size ) ) ) {
			RecordMemoryAddressToArray ( allocated_memory , size );
		}
	}

	return	allocated_memory;	
}

void		gtk_free ( void *MemAddr )
{
	if ( NULL != MemAddr ) {
		DeleteRecordFromArray ( MemAddr );
		free ( MemAddr );
	}
	return;
}

#else

void		*gtk_malloc ( size_t size )
{
	return	malloc ( size );
}

void		gtk_free ( void *MemAddr )
{
	if ( NULL != MemAddr ) {
		free ( MemAddr );
	}
	return;
}

#endif		/* end of _GTK_MM_System_ */

